diff -Nurp '--exclude=.bzr*' tin-2.6.4/src/filter.c tin-2.6.5/src/filter.c
--- tin-2.6.4/src/filter.c	2024-12-09 15:14:54.000000000 +0100
+++ tin-2.6.5/src/filter.c	2025-12-17 08:15:56.473920622 +0100
@@ -3,10 +3,10 @@
  *  Module    : filter.c
  *  Author    : I. Lea
  *  Created   : 1992-12-28
- *  Updated   : 2024-12-09
+ *  Updated   : 2025-12-17
  *  Notes     : Filter articles. Kill & auto selection are supported.
  *
- * Copyright (c) 1991-2025 Iain Lea <iain@bricbrac.de>
+ * Copyright (c) 1991-2026 Iain Lea <iain@bricbrac.de>
  * All rights reserved.
  *
  * Redistribution and use in source and binary forms, with or without
@@ -96,7 +96,7 @@ int filter_file_offset;
 /*
  * Local prototypes
  */
-static int get_choice(int x, const char *help, const char *prompt, const char *list[], int list_size);
+static int get_choice(int x, const char *help, const char *prompt, const char * const list[], int list_size);
 static int set_filter_scope(struct t_group *group);
 static struct t_filter_comment *add_filter_comment(struct t_filter_comment *ptr, char *text);
 static struct t_filter_comment *free_filter_comment(struct t_filter_comment *ptr);
@@ -219,8 +219,16 @@ test_match(
 			error = match_regex_ex(string, (REGEX_SIZE) strlen(string), 0, 0, cache);
 			if (error >= 0)
 				return 1;
-			else if (error != REGEX_ERROR_NOMATCH) { /* also exclude BADUTF8 ? */
+			else if (error != REGEX_ERROR_NOMATCH) {
+				/* also exclude BADUTF8 ?
+				 * #ifdef HAVE_LIB_PCRE2
+				 *	if (error < PCRE2_ERROR_UTF32_ERR2 || error > PCRE2_ERROR_UTF8_ERR1)
+				 * #else
+				 *	if (error == PCRE_ERROR_BADUTF8)
+				 * #endif
+				 */
 				error_message(2, _(txt_pcre_error_num), error);
+
 #ifdef DEBUG
 				if (debug & DEBUG_FILTER) {
 					debug_print_file("FILTER", _(txt_pcre_error_num), error);
@@ -328,30 +336,28 @@ read_filter_file(
 	struct t_filter *ptr = NULL;
 	t_bool need_write = FALSE;
 	t_bool no_version_line = TRUE;
-	t_bool expired_time = FALSE;
-	time_t current_secs = (time_t) 0;
+	time_t current_secs;
 	static t_bool first_read = TRUE;
 	struct t_version *upgrade = NULL;
 
+	/* Reset all filter arrays */
+	free_filter_array(&glob_filter);
+
 	if ((fp = tin_fopen(file, "r")) == NULL)
 		return FALSE;
 
 	if (!batch_mode || verbose)
 		wait_message(0, _(txt_reading_filter_file), file);
 
-	(void) time(&current_secs);
-
-	/*
-	 * Reset all filter arrays if doing a reread of the active file
-	 */
-	if (!first_read)
-		free_filter_array(&glob_filter);
-
 	filter_file_offset = 1;
 	scope[0] = '\0';
-	while (fgets(buf, (int) sizeof(buf), fp) != NULL) {
+
+	(void) time(&current_secs);
+
+	while (fgets(buf, sizeof(buf), fp) != NULL) {
 		if (*buf == '\n')
 			continue;
+
 		/* sanity check for mixed up -F/-f */
 		if (!i && first_read && no_version_line) {
 			/*
@@ -379,10 +385,8 @@ read_filter_file(
 
 		switch (my_tolower((unsigned char) buf[0])) {
 			case 'c':
-				if (match_integer(buf + 1, "ase=", &icase, 1)) {
-					if (ptr && !expired_time)
-						ptr[i].icase = (t_bool) icase;
-
+				if (ptr && match_integer(buf + 1, "ase=", &icase, 1)) {
+					ptr[i].icase = (t_bool) icase;
 					break;
 				}
 				if (match_string(buf + 1, "omment=", comment_line, sizeof(comment_line))) {
@@ -392,17 +396,15 @@ read_filter_file(
 				break;
 
 			case 'f':
-				if (match_string(buf + 1, "rom=", from, sizeof(from))) {
-					if (ptr && !expired_time) {
-						if (tinrc.wildcard && ptr[i].from != NULL) {
-							/* merge with already read value */
-							ptr[i].from = my_realloc(ptr[i].from, strlen(ptr[i].from) + strlen(from) + 2);
-							strcat(ptr[i].from, "|");
-							strcat(ptr[i].from, from);
-						} else {
-							FreeIfNeeded(ptr[i].from);
-							ptr[i].from = my_strdup(from);
-						}
+				if (ptr && match_string(buf + 1, "rom=", from, sizeof(from))) {
+					if (tinrc.wildcard && ptr[i].from != NULL) {
+						/* merge with already read value */
+						ptr[i].from = my_realloc(ptr[i].from, strlen(ptr[i].from) + strlen(from) + 2);
+						strcat(ptr[i].from, "|");
+						strcat(ptr[i].from, from);
+					} else {
+						FreeIfNeeded(ptr[i].from);
+						ptr[i].from = my_strdup(from);
 					}
 				}
 				break;
@@ -420,7 +422,6 @@ read_filter_file(
 					ptr = glob_filter.filter;
 					i = glob_filter.num++;
 					set_filter(&ptr[i]);
-					expired_time = FALSE;
 					ptr[i].scope = my_strdup(scope);
 					if (comment != NULL) {
 						ptr[i].comment = copy_filter_comment(comment, ptr[i].comment);
@@ -436,137 +437,124 @@ read_filter_file(
 					secs = 0L;
 					break;
 				}
-				if (match_string(buf + 1, "nksa=", gnksa, sizeof(gnksa))) {
-					if (ptr && !expired_time) {
-						if (gnksa[0] == '<') {
-							ptr[i].gnksa_cmp = FILTER_LINES_LT;
-							ptr[i].gnksa_num = s2i(&gnksa[1], GNKSA_OK, GNKSA_MISSING_REALNAME);
-						} else if (gnksa[0] == '>') {
-							ptr[i].gnksa_cmp = FILTER_LINES_GT;
-							ptr[i].gnksa_num = s2i(&gnksa[1], GNKSA_OK, GNKSA_MISSING_REALNAME);
-						} else {
-							ptr[i].gnksa_cmp = FILTER_LINES_EQ;
-							ptr[i].gnksa_num = s2i(gnksa, GNKSA_OK, GNKSA_MISSING_REALNAME);
-						}
+
+				if (ptr && match_string(buf + 1, "nksa=", gnksa, sizeof(gnksa))) {
+					if (gnksa[0] == '<') {
+						ptr[i].gnksa_cmp = FILTER_LINES_LT;
+						ptr[i].gnksa_num = s2i(&gnksa[1], GNKSA_OK, GNKSA_MISSING_REALNAME);
+					} else if (gnksa[0] == '>') {
+						ptr[i].gnksa_cmp = FILTER_LINES_GT;
+						ptr[i].gnksa_num = s2i(&gnksa[1], GNKSA_OK, GNKSA_MISSING_REALNAME);
+					} else {
+						ptr[i].gnksa_cmp = FILTER_LINES_EQ;
+						ptr[i].gnksa_num = s2i(gnksa, GNKSA_OK, GNKSA_MISSING_REALNAME);
 					}
 				}
 				break;
 
 			case 'l':
-				if (match_string(buf + 1, "ines=", buffer, sizeof(buffer))) {
-					if (ptr && !expired_time) {
-						if (buffer[0] == '<') {
-							ptr[i].lines_cmp = FILTER_LINES_LT;
-							ptr[i].lines_num = s2i(&buffer[1], 0, INT_MAX);
-						} else if (buffer[0] == '>') {
-							ptr[i].lines_cmp = FILTER_LINES_GT;
-							ptr[i].lines_num = s2i(&buffer[1], 0, INT_MAX);
-						} else {
-							ptr[i].lines_cmp = FILTER_LINES_EQ;
-							ptr[i].lines_num = s2i(buffer, 0, INT_MAX);
-						}
+				if (ptr && match_string(buf + 1, "ines=", buffer, sizeof(buffer))) {
+					if (buffer[0] == '<') {
+						ptr[i].lines_cmp = FILTER_LINES_LT;
+						ptr[i].lines_num = s2i(&buffer[1], 0, INT_MAX);
+					} else if (buffer[0] == '>') {
+						ptr[i].lines_cmp = FILTER_LINES_GT;
+						ptr[i].lines_num = s2i(&buffer[1], 0, INT_MAX);
+					} else {
+						ptr[i].lines_cmp = FILTER_LINES_EQ;
+						ptr[i].lines_num = s2i(buffer, 0, INT_MAX);
 					}
 				}
 				break;
 
 			case 'm':
-				if (match_string(buf + 1, "sgid=", msgid, sizeof(msgid))) {
-					if (ptr && !expired_time) {
-						if (tinrc.wildcard && ptr[i].msgid != NULL && ptr[i].fullref == FILTER_MSGID) {
-							/* merge with already read value */
-							ptr[i].msgid = my_realloc(ptr[i].msgid, strlen(ptr[i].msgid) + strlen(msgid) + 2);
-							strcat(ptr[i].msgid, "|");
-							strcat(ptr[i].msgid, msgid);
-						} else {
-							FreeIfNeeded(ptr[i].msgid);
-							ptr[i].msgid = my_strdup(msgid);
-							ptr[i].fullref = FILTER_MSGID;
-						}
+				if (ptr && match_string(buf + 1, "sgid=", msgid, sizeof(msgid))) {
+					if (tinrc.wildcard && ptr[i].msgid != NULL && ptr[i].fullref == FILTER_MSGID) {
+						/* merge with already read value */
+						ptr[i].msgid = my_realloc(ptr[i].msgid, strlen(ptr[i].msgid) + strlen(msgid) + 2);
+						strcat(ptr[i].msgid, "|");
+						strcat(ptr[i].msgid, msgid);
+					} else {
+						FreeIfNeeded(ptr[i].msgid);
+						ptr[i].msgid = my_strdup(msgid);
+						ptr[i].fullref = FILTER_MSGID;
 					}
 					break;
 				}
-				if (match_string(buf + 1, "sgid_last=", msgid, sizeof(msgid))) {
-					if (ptr && !expired_time) {
-						if (tinrc.wildcard && ptr[i].msgid != NULL && ptr[i].fullref == FILTER_MSGID_LAST) {
-							/* merge with already read value */
-							ptr[i].msgid = my_realloc(ptr[i].msgid, strlen(ptr[i].msgid) + strlen(msgid) + 2);
-							strcat(ptr[i].msgid, "|");
-							strcat(ptr[i].msgid, msgid);
-						} else {
-							FreeIfNeeded(ptr[i].msgid);
-							ptr[i].msgid = my_strdup(msgid);
-							ptr[i].fullref = FILTER_MSGID_LAST;
-						}
+
+				if (ptr && match_string(buf + 1, "sgid_last=", msgid, sizeof(msgid))) {
+					if (tinrc.wildcard && ptr[i].msgid != NULL && ptr[i].fullref == FILTER_MSGID_LAST) {
+						/* merge with already read value */
+						ptr[i].msgid = my_realloc(ptr[i].msgid, strlen(ptr[i].msgid) + strlen(msgid) + 2);
+						strcat(ptr[i].msgid, "|");
+						strcat(ptr[i].msgid, msgid);
+					} else {
+						FreeIfNeeded(ptr[i].msgid);
+						ptr[i].msgid = my_strdup(msgid);
+						ptr[i].fullref = FILTER_MSGID_LAST;
 					}
 					break;
 				}
-				if (match_string(buf + 1, "sgid_only=", msgid, sizeof(msgid))) {
-					if (ptr && !expired_time) {
-						if (tinrc.wildcard && ptr[i].msgid != NULL && ptr[i].fullref == FILTER_MSGID_ONLY) {
-							/* merge with already read value */
-							ptr[i].msgid = my_realloc(ptr[i].msgid, strlen(ptr[i].msgid) + strlen(msgid) + 2);
-							strcat(ptr[i].msgid, "|");
-							strcat(ptr[i].msgid, msgid);
-						} else {
-							FreeIfNeeded(ptr[i].msgid);
-							ptr[i].msgid = my_strdup(msgid);
-							ptr[i].fullref = FILTER_MSGID_ONLY;
-						}
+
+				if (ptr && match_string(buf + 1, "sgid_only=", msgid, sizeof(msgid))) {
+					if (tinrc.wildcard && ptr[i].msgid != NULL && ptr[i].fullref == FILTER_MSGID_ONLY) {
+						/* merge with already read value */
+						ptr[i].msgid = my_realloc(ptr[i].msgid, strlen(ptr[i].msgid) + strlen(msgid) + 2);
+						strcat(ptr[i].msgid, "|");
+						strcat(ptr[i].msgid, msgid);
+					} else {
+						FreeIfNeeded(ptr[i].msgid);
+						ptr[i].msgid = my_strdup(msgid);
+						ptr[i].fullref = FILTER_MSGID_ONLY;
 					}
 				}
 				break;
 
 			case 'p':
-				if (match_string(buf + 1, "ath=", path, sizeof(path))) {
+				if (ptr && match_string(buf + 1, "ath=", path, sizeof(path))) {
 					str_trim(path);
-					if (ptr && !expired_time) {
-						if (tinrc.wildcard && ptr[i].path != NULL) {
-							/* merge with already read value */
-							ptr[i].path = my_realloc(ptr[i].path, strlen(ptr[i].path) + strlen(path) + 2);
-							strcat(ptr[i].path, "|");
-							strcat(ptr[i].path, path);
-						} else {
-							FreeIfNeeded(ptr[i].path);
-							ptr[i].path = my_strdup(path);
-						}
+					if (tinrc.wildcard && ptr[i].path != NULL) {
+						/* merge with already read value */
+						ptr[i].path = my_realloc(ptr[i].path, strlen(ptr[i].path) + strlen(path) + 2);
+						strcat(ptr[i].path, "|");
+						strcat(ptr[i].path, path);
+					} else {
+						FreeIfNeeded(ptr[i].path);
+						ptr[i].path = my_strdup(path);
 					}
 				}
 				break;
 
 			case 'r':
-				if (match_string(buf + 1, "efs_only=", msgid, sizeof(msgid))) {
-					if (ptr && !expired_time) {
-						if (tinrc.wildcard && ptr[i].msgid != NULL && ptr[i].fullref == FILTER_REFS_ONLY) {
-							/* merge with already read value */
-							ptr[i].msgid = my_realloc(ptr[i].msgid, strlen(ptr[i].msgid) + strlen(msgid) + 2);
-							strcat(ptr[i].msgid, "|");
-							strcat(ptr[i].msgid, msgid);
-						} else {
-							FreeIfNeeded(ptr[i].msgid);
-							ptr[i].msgid = my_strdup(msgid);
-							ptr[i].fullref = FILTER_REFS_ONLY;
-						}
+				if (ptr && match_string(buf + 1, "efs_only=", msgid, sizeof(msgid))) {
+					if (tinrc.wildcard && ptr[i].msgid != NULL && ptr[i].fullref == FILTER_REFS_ONLY) {
+						/* merge with already read value */
+						ptr[i].msgid = my_realloc(ptr[i].msgid, strlen(ptr[i].msgid) + strlen(msgid) + 2);
+						strcat(ptr[i].msgid, "|");
+						strcat(ptr[i].msgid, msgid);
+					} else {
+						FreeIfNeeded(ptr[i].msgid);
+						ptr[i].msgid = my_strdup(msgid);
+						ptr[i].fullref = FILTER_REFS_ONLY;
 					}
 				}
 				break;
 
 			case 's':
-				if (match_string(buf + 1, "ubj=", subj, sizeof(subj))) {
-					if (ptr && !expired_time) {
-						if (tinrc.wildcard && ptr[i].subj != NULL) {
-							/* merge with already read value */
-							ptr[i].subj = my_realloc(ptr[i].subj, strlen(ptr[i].subj) + strlen(subj) + 2);
-							strcat(ptr[i].subj, "|");
-							strcat(ptr[i].subj, subj);
-						} else {
-							FreeIfNeeded(ptr[i].subj);
-							ptr[i].subj = my_strdup(subj);
-						}
+				if (ptr && match_string(buf + 1, "ubj=", subj, sizeof(subj))) {
+					if (tinrc.wildcard && ptr[i].subj != NULL) {
+						/* merge with already read value */
+						ptr[i].subj = my_realloc(ptr[i].subj, strlen(ptr[i].subj) + strlen(subj) + 2);
+						strcat(ptr[i].subj, "|");
+						strcat(ptr[i].subj, subj);
+					} else {
+						FreeIfNeeded(ptr[i].subj);
+						ptr[i].subj = my_strdup(subj);
+					}
 #ifdef DEBUG
-						if (debug & DEBUG_FILTER)
-							debug_print_file("FILTER", "buf=[%s]  Gsubj=[%s]", ptr[i].subj, glob_filter.filter[i].subj);
+					if (debug & DEBUG_FILTER)
+						debug_print_file("FILTER", "buf=[%s]  Gsubj=[%s]", ptr[i].subj, glob_filter.filter[i].subj);
 #endif /* DEBUG */
-					}
 					break;
 				}
 
@@ -579,7 +567,7 @@ read_filter_file(
 					if (debug & DEBUG_FILTER)
 						debug_print_file("FILTER", "score=[%d]", score);
 #endif /* DEBUG */
-					if (ptr && !expired_time) {
+					if (ptr) {
 						if (!score) {
 							if (!strncasecmp(scbuf, "kill", 4))
 								score = tinrc.score_kill;
@@ -594,19 +582,14 @@ read_filter_file(
 				break;
 
 			case 't':
-				if (match_long(buf + 1, "ime=", &secs)) {
-					if (ptr && !expired_time) {
-						ptr[i].time = (time_t) secs;
-						/* rule expired? */
-						if (secs && current_secs > (time_t) secs) {
+				if (ptr && match_long(buf + 1, "ime=", &secs)) {
+					ptr[i].time = (time_t) secs;
+					if (secs && current_secs > (time_t) secs) {
+						need_write = TRUE;
 #ifdef DEBUG
-							if (debug & DEBUG_FILTER)
-								debug_print_file("FILTER", "EXPIRED  secs=[%lu]  current_secs=[%lu]", (unsigned long int) secs, (unsigned long int) current_secs);
+						if (debug & DEBUG_FILTER)
+							debug_print_file("FILTER", "EXPIRED  secs=[%lu]  current_secs=[%lu]", (unsigned long int) secs, (unsigned long int) current_secs);
 #endif /* DEBUG */
-							glob_filter.num--;
-							expired_time = TRUE;
-							need_write = TRUE;
-						}
 					}
 				}
 				break;
@@ -618,19 +601,18 @@ read_filter_file(
 				 */
 				if (ptr && match_string(buf + 1, "ref=", xref, sizeof(xref))) {
 					str_trim(xref);
-					if (!expired_time) {
-						if (tinrc.wildcard && ptr[i].xref != NULL) {
-							/* merge with already read value */
-							ptr[i].xref = my_realloc(ptr[i].xref, strlen(ptr[i].xref) + strlen(xref) + 2);
-							strcat(ptr[i].xref, "|");
-							strcat(ptr[i].xref, xref);
-						} else {
-							FreeIfNeeded(ptr[i].xref);
-							ptr[i].xref = my_strdup(xref);
-						}
+					if (tinrc.wildcard && ptr[i].xref != NULL) {
+						/* merge with already read value */
+						ptr[i].xref = my_realloc(ptr[i].xref, strlen(ptr[i].xref) + strlen(xref) + 2);
+						strcat(ptr[i].xref, "|");
+						strcat(ptr[i].xref, xref);
+					} else {
+						FreeIfNeeded(ptr[i].xref);
+						ptr[i].xref = my_strdup(xref);
 					}
 					break;
 				}
+
 				if (ptr && ((upgrade && upgrade->state == RC_UPGRADE) || no_version_line)) {
 					char foo[HEADER_LEN];
 
@@ -773,16 +755,20 @@ write_filter_array(
 
 	for (i = 0; i < ptr->num; i++) {
 #ifdef DEBUG
-		if (debug & DEBUG_FILTER)
-			debug_print_file("FILTER", "WRITE i=[%d] subj=[%s] from=[%s]\n", i, BlankIfNull(ptr->filter[i].subj), BlankIfNull(ptr->filter[i].from));
+		if (debug & DEBUG_FILTER) {
+			debug_print_file("FILTER", "\nWRITE i=[%d] subj=[%s] from=[%s]", i, BlankIfNull(ptr->filter[i].subj), BlankIfNull(ptr->filter[i].from));
+			debug_print_file("FILTER", "Scope=[%s]", (ptr->filter[i].scope != NULL ? ptr->filter[i].scope : "*"));
+		}
 #endif /* DEBUG */
 
-		if (ptr->filter[i].time && theTime > ptr->filter[i].time)
-			continue;
+		if (ptr->filter[i].time && theTime > ptr->filter[i].time) {
 #ifdef DEBUG
-		if (debug & DEBUG_FILTER)
-			debug_print_file("FILTER", "Scope=[%s]" cCRLF, (ptr->filter[i].scope != NULL ? ptr->filter[i].scope : "*"));
+			if (debug & DEBUG_FILTER)
+				debug_print_file("FILTER", "EXPIRED  secs=[%lu]  current_secs=[%lu]  %s", (unsigned long int) ptr->filter[i].time, (unsigned long int) theTime, tinrc.keep_expired_filters ? "[KEEP]" : "[FORGET]");
 #endif /* DEBUG */
+			if (!tinrc.keep_expired_filters)
+				continue;
+		}
 
 		fprintf(fp, "\n");		/* makes filter file more readable */
 
@@ -903,7 +889,7 @@ get_choice(
 	int x,
 	const char *help,
 	const char *prompt,
-	const char *list[],
+	const char * const list[],
 	int list_size)
 {
 	int ch, y, i = 0;
@@ -1086,6 +1072,7 @@ filter_menu(
 	struct t_filter_rule rule;
 	t_bool proceed;
 	t_bool ret;
+	t_bool has_path_filter = filter_on_path(group);
 	t_function func, default_func = FILTER_SAVE;
 
 	signal_context = cFilter;
@@ -1152,7 +1139,7 @@ filter_menu(
 
 	len = cCOLS - flen - clen - 1 + 4;
 
-	snprintf(text_time, sizeof(text_time), _(txt_time_default_days), tinrc.filter_days);
+	snprintf(text_time, sizeof(text_time), P_(txt_time_default_day_sp[0], txt_time_default_day_sp[1], tinrc.filter_days), tinrc.filter_days);
 	fmt_filter_menu_prompt(text_subj, sizeof(text_subj), ptr_filter_subj, len, art->subject);
 	snprintf(text_score, sizeof(text_score), _(txt_filter_score), (type == GLOBAL_MENU_FILTER_KILL ? tinrc.score_kill : tinrc.score_select));
 	fmt_filter_menu_prompt(text_from, sizeof(text_from), ptr_filter_from, len, art->mailbox.from);
@@ -1188,17 +1175,19 @@ filter_menu(
 	}
 
 	if (rule.text && *rule.text) {
-		list = my_malloc(sizeof(char *) * 8);
-		list[0] = _(txt_subj_line_only_case);
-		list[1] = _(txt_subj_line_only);
-		list[2] = _(txt_from_line_only_case);
-		list[3] = _(txt_from_line_only);
-		list[4] = _(txt_msgid_refs_line);
-		list[5] = _(txt_msgid_line_last);
-		list[6] = _(txt_msgid_line_only);
-		list[7] = _(txt_refs_line_only);
+		list = my_malloc(sizeof(char *) * FILTER_LIST_MAX);
+		list[FILTER_SUBJ_CASE_SENSITIVE] = _(txt_subj_line_only_case);
+		list[FILTER_SUBJ_CASE_IGNORE] = _(txt_subj_line_only);
+		list[FILTER_FROM_CASE_SENSITIVE] = _(txt_from_line_only_case);
+		list[FILTER_FROM_CASE_IGNORE] = _(txt_from_line_only);
+		list[FILTER_MSGID] = _(txt_msgid_refs_line);
+		list[FILTER_MSGID_LAST] = _(txt_msgid_line_last);
+		list[FILTER_MSGID_ONLY] = _(txt_msgid_line_only);
+		list[FILTER_REFS_ONLY] = _(txt_refs_line_only);
+		list[FILTER_XREF_CASE_IGNORE] = _(txt_xref_line_nocasse); /* RFC 5536 3.1.4 "... SHOULD NOT contain uppercase letters." */
+		list[FILTER_PATH_CASE_IGNORE] = _(txt_path_line_nocasse); /* RFC 5537 3.2 "... SHOULD compare identities case-insensitively." */
 
-		i = get_choice(INDEX_TOP + 3, _(txt_help_filter_text_type), _(txt_filter_text_type), list, 8);
+		i = get_choice(INDEX_TOP + 3, _(txt_help_filter_text_type), _(txt_filter_text_type), list, FILTER_LIST_MAX);
 		free(list);
 
 		if (i == -1) {
@@ -1211,6 +1200,8 @@ filter_menu(
 		switch (i) {
 			case FILTER_SUBJ_CASE_IGNORE:
 			case FILTER_FROM_CASE_IGNORE:
+			case FILTER_PATH_CASE_IGNORE:
+			case FILTER_XREF_CASE_IGNORE:
 				rule.icase = TRUE;
 				break;
 
@@ -1506,6 +1497,11 @@ filter_menu(
 			 * Add the filter rule and save it to the filter file
 			 */
 			ret = add_filter_rule(group, art, &rule, FALSE);
+			if (!art->path && !has_path_filter && filter_on_path(group)) { /* we don't have Path-data yet */
+				index_group(group, TRUE); /* fetch Path:-data */
+				if (serverrc.cache_overview_files) /* update cache */
+					write_overview(group);
+			}
 			FreeIfNeeded(rule.text);
 			FreeIfNeeded(rule.scope);
 			free_filter_comment(rule.comment);
@@ -1528,7 +1524,7 @@ filter_menu(
 t_bool
 quick_filter(
 	t_function type,
-	struct t_group *group,
+	const struct t_group *group,
 	struct t_article *art)
 {
 	const char *scope;
@@ -1542,13 +1538,13 @@ quick_filter(
 		expire = group->attribute->quick_kill_expire;
 		/* ON=case sensitive, OFF=ignore case -> invert */
 		icase = bool_not(group->attribute->quick_kill_case);
-		scope = group->attribute->quick_kill_scope ? BlankIfNull(*group->attribute->quick_kill_scope) : "";
+		scope = group->attribute->quick_kill_scope ? *group->attribute->quick_kill_scope : "";
 	} else {	/* type == GLOBAL_QUICK_FILTER_SELECT */
 		header = group->attribute->quick_select_header;
 		expire = group->attribute->quick_select_expire;
 		/* ON=case sensitive, OFF=ignore case -> invert */
 		icase = bool_not(group->attribute->quick_select_case);
-		scope = group->attribute->quick_select_scope ? BlankIfNull(*group->attribute->quick_select_scope) : "";
+		scope = group->attribute->quick_select_scope ? *group->attribute->quick_select_scope : "";
 	}
 
 #ifdef DEBUG
@@ -1761,6 +1757,16 @@ add_filter_rule(
 				ptr[i].fullref = rule->counter;
 				break;
 
+			case FILTER_XREF_CASE_IGNORE:
+				ptr[i].xref = my_strdup(acbuf);
+				str_lwr(ptr[i].xref);
+				break;
+
+			case FILTER_PATH_CASE_IGNORE:
+				ptr[i].path = my_strdup(acbuf);
+				str_lwr(ptr[i].path);
+				break;
+
 			default: /* should not happen */
 				/* CONSTANTCONDITION */
 				assert(0 != 0);
@@ -1882,6 +1888,10 @@ filter_articles(
 	t_bool filtered = FALSE;
 	t_bool error = FALSE;
 	t_bool use_regex = tinrc.wildcard ? TRUE : FALSE;
+	static time_t current_secs = (time_t) 0;
+
+	if (!current_secs)
+		time(&current_secs);
 
 	/*
 	 * check if there are any global filter rules
@@ -1897,7 +1907,7 @@ filter_articles(
 	 * ie. group=comp.os.linux.help  scope=comp.os.linux.*
 	 */
 	inscope = set_filter_scope(group);
-	if (!cmd_line && !batch_mode)
+	if (!cmd_line && !batch_mode) /* FIXME: txt_filter_global_rules always uses plural-form "rules" */
 		wait_message(0, _(txt_filter_global_rules), inscope, group->glob_filter->num);
 	num = group->glob_filter->num;
 	ptr = group->glob_filter->filter;
@@ -1938,6 +1948,14 @@ filter_articles(
 			continue;
 
 		for (j = 0; j < num && !error; j++) {
+			if (ptr[j].time && current_secs > ptr[j].time) {
+#ifdef DEBUG
+				if ((debug & DEBUG_FILTER) && verbose > 1) /* very noisy */
+					debug_print_file("FILTER", "article %d EXPIRED rule %d secs=[%lu]  current_secs=[%lu]", i, j, (unsigned long int) ptr[j].time, (unsigned long int) current_secs);
+#endif /* DEBUG */
+				continue;
+			}
+
 			if (ptr[j].inscope) {
 				/*
 				 * Filter on Subject: line
@@ -2120,11 +2138,11 @@ filter_articles(
 				 */
 				if (arts[i].xref && *arts[i].xref) {
 					if (ptr[j].score && ptr[j].xref != NULL) {
-						char *s, *e, *k;
+						char *e, *k;
+						const char *s = arts[i].xref;
 						t_bool skip = FALSE;
 
-						s = arts[i].xref;
-						if (strchr(s, ' ') || strchr(s, '\t')) {
+						if (strpbrk(s, " \t")) {
 							while (*s && !isspace((unsigned char) *s))	/* skip server name */
 								++s;
 							while (*s && isspace((unsigned char) *s))
@@ -2190,7 +2208,7 @@ filter_articles(
 				/*
 				 * Filter on Path: lines
 				 */
-				if (arts[i].path && *arts[i].path) {
+				if (arts[i].path) {
 					if (ptr[j].path != NULL) {
 						switch (test_match(arts[i].path, ptr[j].path, ptr[j].icase, use_regex, &regex_cache_path[j])) {
 							case 1:
@@ -2270,21 +2288,18 @@ filter_on_path(
 {
 	int i;
 	const struct t_filter *flt;
-	t_bool ret = FALSE;
 
 	if (group->glob_filter->num == 0)
-		return ret;
+		return FALSE;
 
 	if (set_filter_scope(group)) {
 		flt = group->glob_filter->filter;
 		for (i = 0; i < group->glob_filter->num; i++) {
-			if (flt[i].inscope && flt[i].path) {
-				ret = TRUE;
-				break;
-			}
+			if (flt[i].inscope && flt[i].path)
+				return TRUE;
 		}
 	}
-	return ret;
+	return FALSE;
 }
 
 
diff -Nurp '--exclude=.bzr*' tin-2.6.4/src/getline.c tin-2.6.5/src/getline.c
--- tin-2.6.4/src/getline.c	2024-11-25 20:40:37.000000000 +0100
+++ tin-2.6.5/src/getline.c	2025-11-29 08:22:13.827166392 +0100
@@ -3,7 +3,7 @@
  *  Module    : getline.c
  *  Author    : Chris Thewalt & Iain Lea
  *  Created   : 1991-11-09
- *  Updated   : 2024-09-20
+ *  Updated   : 2025-11-29
  *  Notes     : emacs style line editing input package.
  *  Copyright : (c) Copyright 1991-99 by Chris Thewalt & Iain Lea
  *              Permission to use, copy, modify, and distribute this
@@ -89,7 +89,7 @@ tin_getline(
 	t_bool passwd,
 	int which_hist)
 {
-	int c, i, loc, tmp, gl_max;
+	int c, i, loc, tmp, gl_max = -1;
 	char *tprompt;
 #if defined(MULTIBYTE_ABLE) && !defined(NO_LOCALE)
 	wint_t wc;
@@ -115,8 +115,8 @@ tin_getline(
 
 	if (max_chars == 0) {
 		if (number_only)
-			gl_max = 10;
-		else
+			gl_max = snprintf(NULL, 0, "%d", number_only == 1 ? INT_MAX : INT_MIN);
+		if (gl_max < 0)
 			gl_max = BUF_SIZE;
 	} else
 		gl_max = max_chars;
@@ -731,7 +731,7 @@ hist_prev(
 				size = 0;
 			gl_buf[size] = (wchar_t) '\0';
 #else
-			strcpy(gl_buf, input_history[w][hist_pos[w]]);
+			STRCPY(gl_buf, input_history[w][hist_pos[w]]);
 #endif /* MULTIBYTE_ABLE && !NO_LOCALE */
 		} else
 			ring_bell();
@@ -764,7 +764,7 @@ hist_next(
 				size = 0;
 			gl_buf[size] = (wchar_t) '\0';
 #else
-			strcpy(gl_buf, input_history[w][hist_pos[w]]);
+			STRCPY(gl_buf, input_history[w][hist_pos[w]]);
 #endif /* MULTIBYTE_ABLE && !NO_LOCALE */
 		} else
 			gl_buf[0] = 0;
diff -Nurp '--exclude=.bzr*' tin-2.6.4/src/global.c tin-2.6.5/src/global.c
--- tin-2.6.4/src/global.c	2024-11-25 20:40:37.000000000 +0100
+++ tin-2.6.5/src/global.c	2025-11-13 02:21:32.384171442 +0100
@@ -3,10 +3,10 @@
  *  Module    : global.c
  *  Author    : Jason Faultless <jason@altarstone.com>
  *  Created   : 1999-12-12
- *  Updated   : 2024-10-17
+ *  Updated   : 2025-01-30
  *  Notes     : Generic navigation and key handling routines
  *
- * Copyright (c) 1999-2025 Jason Faultless <jason@altarstone.com>
+ * Copyright (c) 1999-2026 Jason Faultless <jason@altarstone.com>
  * All rights reserved.
  *
  * Redistribution and use in source and binary forms, with or without
@@ -414,7 +414,13 @@ handle_keypad(
 			break;
 
 		default:
-			func = key_to_func((wchar_t) ch, keys);
+			if (ch < FUNC_MAX) {
+#if defined(MULTIBYTE_ABLE) && !defined(NO_LOCALE)
+				func = key_to_func((wchar_t) ch, keys);
+#else
+				func = key_to_func((char) ch, keys);
+#endif /* MULTIBYTE_ABLE && !NO_LOCALE */
+			}
 			break;
 	}
 	return func;
